CfnRotationSchedule L1 construct
Configure the rotation schedule and Lambda rotation function for a secret. For more information, see How rotation works .
For database credentials, refer to the following resources:
- Amazon RDS master user credentials: AWS::RDS::DBCluster MasterUserSecret
- Amazon Redshift admin user credentials: AWS::Redshift::Cluster
Choose one of the following options for the rotation function:
- Create a new rotation function using
HostedRotationLambdabased on a Secrets Manager rotation function template . - Use an existing rotation function by specifying its ARN with
RotationLambdaARN.
For database secrets defined in the same CloudFormation template as the database or service:
- Use the AWS::SecretsManager::SecretTargetAttachment resource to populate the secret with connection details.
- Add a
DependsOnattribute to theRotationScheduleresource that uses aSecretTargetAttachment. This ensures the rotation is configured after the secret is populated with connection details. > You can define only one rotation schedule per secret.
Example
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import { aws_secretsmanager as secretsmanager } from 'aws-cdk-lib';
const cfnRotationSchedule = new secretsmanager.CfnRotationSchedule(this, 'MyCfnRotationSchedule', {
secretId: 'secretId',
// the properties below are optional
externalSecretRotationMetadata: [{
key: 'key',
value: 'value',
}],
externalSecretRotationRoleArn: 'externalSecretRotationRoleArn',
hostedRotationLambda: {
rotationType: 'rotationType',
// the properties below are optional
excludeCharacters: 'excludeCharacters',
kmsKeyArn: 'kmsKeyArn',
masterSecretArn: 'masterSecretArn',
masterSecretKmsKeyArn: 'masterSecretKmsKeyArn',
rotationLambdaName: 'rotationLambdaName',
runtime: 'runtime',
superuserSecretArn: 'superuserSecretArn',
superuserSecretKmsKeyArn: 'superuserSecretKmsKeyArn',
vpcSecurityGroupIds: 'vpcSecurityGroupIds',
vpcSubnetIds: 'vpcSubnetIds',
},
rotateImmediatelyOnUpdate: false,
rotationLambdaArn: 'rotationLambdaArn',
rotationRules: {
automaticallyAfterDays: 123,
duration: 'duration',
scheduleExpression: 'scheduleExpression',
},
});
# The code below shows an example of how to instantiate this type.
# The values are placeholders you should change.
from aws_cdk import aws_secretsmanager as secretsmanager
cfn_rotation_schedule = secretsmanager.CfnRotationSchedule(self, "MyCfnRotationSchedule",
secret_id="secretId",
# the properties below are optional
external_secret_rotation_metadata=[secretsmanager.CfnRotationSchedule.ExternalSecretRotationMetadataItemProperty(
key="key",
value="value"
)],
external_secret_rotation_role_arn="externalSecretRotationRoleArn",
hosted_rotation_lambda=secretsmanager.CfnRotationSchedule.HostedRotationLambdaProperty(
rotation_type="rotationType",
# the properties below are optional
exclude_characters="excludeCharacters",
kms_key_arn="kmsKeyArn",
master_secret_arn="masterSecretArn",
master_secret_kms_key_arn="masterSecretKmsKeyArn",
rotation_lambda_name="rotationLambdaName",
runtime="runtime",
superuser_secret_arn="superuserSecretArn",
superuser_secret_kms_key_arn="superuserSecretKmsKeyArn",
vpc_security_group_ids="vpcSecurityGroupIds",
vpc_subnet_ids="vpcSubnetIds"
),
rotate_immediately_on_update=False,
rotation_lambda_arn="rotationLambdaArn",
rotation_rules=secretsmanager.CfnRotationSchedule.RotationRulesProperty(
automatically_after_days=123,
duration="duration",
schedule_expression="scheduleExpression"
)
)
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import software.amazon.awscdk.services.secretsmanager.*;
CfnRotationSchedule cfnRotationSchedule = CfnRotationSchedule.Builder.create(this, "MyCfnRotationSchedule")
.secretId("secretId")
// the properties below are optional
.externalSecretRotationMetadata(List.of(ExternalSecretRotationMetadataItemProperty.builder()
.key("key")
.value("value")
.build()))
.externalSecretRotationRoleArn("externalSecretRotationRoleArn")
.hostedRotationLambda(HostedRotationLambdaProperty.builder()
.rotationType("rotationType")
// the properties below are optional
.excludeCharacters("excludeCharacters")
.kmsKeyArn("kmsKeyArn")
.masterSecretArn("masterSecretArn")
.masterSecretKmsKeyArn("masterSecretKmsKeyArn")
.rotationLambdaName("rotationLambdaName")
.runtime("runtime")
.superuserSecretArn("superuserSecretArn")
.superuserSecretKmsKeyArn("superuserSecretKmsKeyArn")
.vpcSecurityGroupIds("vpcSecurityGroupIds")
.vpcSubnetIds("vpcSubnetIds")
.build())
.rotateImmediatelyOnUpdate(false)
.rotationLambdaArn("rotationLambdaArn")
.rotationRules(RotationRulesProperty.builder()
.automaticallyAfterDays(123)
.duration("duration")
.scheduleExpression("scheduleExpression")
.build())
.build();
// Install: dotnet add package Amazon.CDK.Lib
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
using Amazon.CDK.AWS.SecretsManager;
var cfnRotationSchedule = new CfnRotationSchedule(this, "MyCfnRotationSchedule", new CfnRotationScheduleProps {
SecretId = "secretId",
// the properties below are optional
ExternalSecretRotationMetadata = new [] { new ExternalSecretRotationMetadataItemProperty {
Key = "key",
Value = "value"
} },
ExternalSecretRotationRoleArn = "externalSecretRotationRoleArn",
HostedRotationLambda = new HostedRotationLambdaProperty {
RotationType = "rotationType",
// the properties below are optional
ExcludeCharacters = "excludeCharacters",
KmsKeyArn = "kmsKeyArn",
MasterSecretArn = "masterSecretArn",
MasterSecretKmsKeyArn = "masterSecretKmsKeyArn",
RotationLambdaName = "rotationLambdaName",
Runtime = "runtime",
SuperuserSecretArn = "superuserSecretArn",
SuperuserSecretKmsKeyArn = "superuserSecretKmsKeyArn",
VpcSecurityGroupIds = "vpcSecurityGroupIds",
VpcSubnetIds = "vpcSubnetIds"
},
RotateImmediatelyOnUpdate = false,
RotationLambdaArn = "rotationLambdaArn",
RotationRules = new RotationRulesProperty {
AutomaticallyAfterDays = 123,
Duration = "duration",
ScheduleExpression = "scheduleExpression"
}
});
// Install: go get github.com/aws/aws-cdk-go/awscdk/v2
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import "github.com/aws/aws-cdk-go/awscdk"
cfnRotationSchedule := awscdk.Aws_secretsmanager.NewCfnRotationSchedule(this, jsii.String("MyCfnRotationSchedule"), &CfnRotationScheduleProps{
SecretId: jsii.String("secretId"),
// the properties below are optional
ExternalSecretRotationMetadata: []interface{}{
&ExternalSecretRotationMetadataItemProperty{
Key: jsii.String("key"),
Value: jsii.String("value"),
},
},
ExternalSecretRotationRoleArn: jsii.String("externalSecretRotationRoleArn"),
HostedRotationLambda: &HostedRotationLambdaProperty{
RotationType: jsii.String("rotationType"),
// the properties below are optional
ExcludeCharacters: jsii.String("excludeCharacters"),
KmsKeyArn: jsii.String("kmsKeyArn"),
MasterSecretArn: jsii.String("masterSecretArn"),
MasterSecretKmsKeyArn: jsii.String("masterSecretKmsKeyArn"),
RotationLambdaName: jsii.String("rotationLambdaName"),
Runtime: jsii.String("runtime"),
SuperuserSecretArn: jsii.String("superuserSecretArn"),
SuperuserSecretKmsKeyArn: jsii.String("superuserSecretKmsKeyArn"),
VpcSecurityGroupIds: jsii.String("vpcSecurityGroupIds"),
VpcSubnetIds: jsii.String("vpcSubnetIds"),
},
RotateImmediatelyOnUpdate: jsii.Boolean(false),
RotationLambdaArn: jsii.String("rotationLambdaArn"),
RotationRules: &RotationRulesProperty{
AutomaticallyAfterDays: jsii.Number(123),
Duration: jsii.String("duration"),
ScheduleExpression: jsii.String("scheduleExpression"),
},
})
Initializer
new CfnRotationSchedule(scope: Construct, id: string, props: CfnRotationScheduleProps)
CfnRotationSchedule(scope: Construct, id: str, props: CfnRotationScheduleProps)
new CfnRotationSchedule(Construct scope, String id, CfnRotationScheduleProps props)
new CfnRotationSchedule(Construct scope, string id, CfnRotationScheduleProps props)
NewCfnRotationSchedule(Scope Construct, Id *string, Props CfnRotationScheduleProps)
Construct Props
externalSecretRotationMetadataoptionalIResolvable | IResolvable | CfnRotationSchedule.ExternalSecretRotationMetadataItemProperty[]external_secret_rotation_metadataoptionaltyping.Union[IResolvable, typing.List[typing.Union[IResolvable, ExternalSecretRotationMetadataItemProperty]]]externalSecretRotationMetadataoptionalIResolvableExternalSecretRotationMetadataoptionalIResolvableExternalSecretRotationMetadataoptionalinterface{}#externalSecretRotationRoleArnoptionalstringexternal_secret_rotation_role_arnoptionalstrexternalSecretRotationRoleArnoptionalStringExternalSecretRotationRoleArnoptionalstringExternalSecretRotationRoleArnoptional*string#hostedRotationLambdaoptionalIResolvable | CfnRotationSchedule.HostedRotationLambdaPropertyhosted_rotation_lambdaoptionaltyping.Union[IResolvable, HostedRotationLambdaProperty]hostedRotationLambdaoptionalIResolvableHostedRotationLambdaoptionalIResolvableHostedRotationLambdaoptionalinterface{}#notes
You must specify Transform: AWS::SecretsManager-2024-09-16 at the beginning of the CloudFormation template. Transforms are macros hosted by AWS CloudFormation that help you create and manage complex infrastructure. The Transform: AWS::SecretsManager-2024-09-16 transform automatically extends the CloudFormation stack to include a nested stack (of type AWS::CloudFormation::Stack ), which then creates and updates on your behalf during subsequent stack operations, the appropriate rotation Lambda function for your database or service. For general information on transforms, see the AWS CloudFormation documentation.
For Amazon RDS master user credentials, see AWS::RDS::DBCluster MasterUserSecret .
For Amazon Redshift admin user credentials, see AWS::Redshift::Cluster .
rotateImmediatelyOnUpdateoptionalboolean | IResolvablerotate_immediately_on_updateoptionaltyping.Union[bool, IResolvable]rotateImmediatelyOnUpdateoptionalBooleanRotateImmediatelyOnUpdateoptionalboolRotateImmediatelyOnUpdateoptionalinterface{}#notes
The rotation schedule is defined in RotationRules .
The default for RotateImmediatelyOnUpdate is true . If you don't specify this value, Secrets Manager rotates the secret immediately.
If you set RotateImmediatelyOnUpdate to false , Secrets Manager tests the rotation configuration by running the testSecret step of the Lambda rotation function. This test creates an AWSPENDING version of the secret and then removes it.
When changing an existing rotation schedule and setting
RotateImmediatelyOnUpdatetofalse:
- If using
AutomaticallyAfterDaysor aScheduleExpressionwithrate(), the previously scheduled rotation might still occur.- To prevent unintended rotations, use a
ScheduleExpressionwithcron()for granular control over rotation windows.
Rotation is an asynchronous process. For more information, see How rotation works .
rotationLambdaArnoptionalstringrotation_lambda_arnoptionalstrrotationLambdaArnoptionalStringRotationLambdaArnoptionalstringRotationLambdaArnoptional*string#notes
To specify a rotation function that is also defined in this template, use the Ref function.
For Amazon RDS master user credentials, see AWS::RDS::DBCluster MasterUserSecret .
For Amazon Redshift admin user credentials, see AWS::Redshift::Cluster .
To create a new rotation function based on one of the Secrets Manager rotation function templates , specify HostedRotationLambda instead.
rotationRulesoptionalIResolvable | CfnRotationSchedule.RotationRulesPropertyrotation_rulesoptionaltyping.Union[IResolvable, RotationRulesProperty]rotationRulesoptionalIResolvableRotationRulesoptionalIResolvableRotationRulesoptionalinterface{}#Properties
CFN_RESOURCE_TYPE_NAMEstringcfn_resource_type_namestrCFN_RESOURCE_TYPE_NAMEStringCFN_RESOURCE_TYPE_NAMEstringCFN_RESOURCE_TYPE_NAME*stringstatic#cfnOptionsICfnResourceOptionscfn_optionsICfnResourceOptionscfnOptionsICfnResourceOptionsCfnOptionsICfnResourceOptionsCfnOptionsICfnResourceOptions#cfnResourceTypestringcfn_resource_typestrcfnResourceTypeStringCfnResourceTypestringCfnResourceType*string#creationStackstring[]creation_stacktyping.List[str]creationStackList<String>CreationStackstring[]CreationStack*[]*string#externalSecretRotationMetadatamay be undefinedIResolvable | IResolvable | CfnRotationSchedule.ExternalSecretRotationMetadataItemProperty[]external_secret_rotation_metadatamay be undefinedtyping.Union[IResolvable, typing.List[typing.Union[IResolvable, ExternalSecretRotationMetadataItemProperty]]]externalSecretRotationMetadatamay be undefinedIResolvableExternalSecretRotationMetadatamay be undefinedIResolvableExternalSecretRotationMetadatamay be undefinedinterface{}#externalSecretRotationRoleArnmay be undefinedstringexternal_secret_rotation_role_arnmay be undefinedstrexternalSecretRotationRoleArnmay be undefinedStringExternalSecretRotationRoleArnmay be undefinedstringExternalSecretRotationRoleArnmay be undefined*string#hostedRotationLambdamay be undefinedIResolvable | CfnRotationSchedule.HostedRotationLambdaPropertyhosted_rotation_lambdamay be undefinedtyping.Union[IResolvable, HostedRotationLambdaProperty]hostedRotationLambdamay be undefinedIResolvableHostedRotationLambdamay be undefinedIResolvableHostedRotationLambdamay be undefinedinterface{}#The logical ID of the element is calculated from the path of the resource node in the construct tree.
To override this value, use overrideLogicalId(newLogicalId).
If, by any chance, the intrinsic reference of a resource is not a string, you could coerce it to an IResolvable through Lazy.any({ produce: resource.ref }).
rotateImmediatelyOnUpdatemay be undefinedboolean | IResolvablerotate_immediately_on_updatemay be undefinedtyping.Union[bool, IResolvable]rotateImmediatelyOnUpdatemay be undefinedBooleanRotateImmediatelyOnUpdatemay be undefinedboolRotateImmediatelyOnUpdatemay be undefinedinterface{}#rotationLambdaArnmay be undefinedstringrotation_lambda_arnmay be undefinedstrrotationLambdaArnmay be undefinedStringRotationLambdaArnmay be undefinedstringRotationLambdaArnmay be undefined*string#rotationRulesmay be undefinedIResolvable | CfnRotationSchedule.RotationRulesPropertyrotation_rulesmay be undefinedtyping.Union[IResolvable, RotationRulesProperty]rotationRulesmay be undefinedIResolvableRotationRulesmay be undefinedIResolvableRotationRulesmay be undefinedinterface{}#rotationScheduleRefRotationScheduleReferencerotation_schedule_refRotationScheduleReferencerotationScheduleRefRotationScheduleReferenceRotationScheduleRefRotationScheduleReferenceRotationScheduleRefRotationScheduleReference#This is unique for each rotation schedule definition.
Methods
addDeletionOverride(path: string): voiddef add_deletion_override(self, path: str) -> Nonepublic void addDeletionOverride(String path)public void AddDeletionOverride(string path)func AddDeletionOverride(Path *string)#1 parameter
Parameters
pathpathpathpathPath— The path of the value to delete.
addDependency(target: CfnResource): voiddef add_dependency(self, target: CfnResource) -> Nonepublic void addDependency(CfnResource target)public void AddDependency(CfnResource target)func AddDependency(Target CfnResource)deprecated#This method has been renamed to addResourceDependency to more clearly set it apart from construct.node.addDependency. See the documentation of that function for more details.
addDependsOn(target: CfnResource): voiddef add_depends_on(self, target: CfnResource) -> Nonepublic void addDependsOn(CfnResource target)public void AddDependsOn(CfnResource target)func AddDependsOn(Target CfnResource)deprecated#notes
This can be used for resources across stacks (or nested stack) boundaries and the dependency will automatically be transferred to the relevant scope.
This method has been renamed to addResourceDependency, which makes it more clear that this method operates at a different level from the construct-level construct.node.addDependency() mechanism.
addMetadata(key: string, value: any): voiddef add_metadata(self, key: str, value: Any) -> Nonepublic void addMetadata(String key, Object value)public void AddMetadata(string key, object value)func AddMetadata(Key *string, Value interface{})#addOverride(path: string, value: any): voiddef add_override(self, path: str, value: Any) -> Nonepublic void addOverride(String path, Object value)public void AddOverride(string path, object value)func AddOverride(Path *string, Value interface{})#notes · 2 parameters
To add a property override, either use addPropertyOverride or prefix path with "Properties." (i.e. Properties.TopicName).
If the override is nested, separate each nested level using a dot (.) in the path parameter. If there is an array as part of the nesting, specify the index in the path.
To include a literal . in the property name, prefix with a \. In most programming languages you will need to write this as "\\." because the \ itself will need to be escaped.
For example,
cfnResource.addOverride('Properties.GlobalSecondaryIndexes.0.Projection.NonKeyAttributes', ['myattribute']);
cfnResource.addOverride('Properties.GlobalSecondaryIndexes.1.ProjectionType', 'INCLUDE');
would add the overrides
"Properties": {
"GlobalSecondaryIndexes": [
{
"Projection": {
"NonKeyAttributes": [ "myattribute" ]
...
}
...
},
{
"ProjectionType": "INCLUDE"
...
},
]
...
}
The value argument to addOverride will not be processed or translated in any way. Pass raw JSON values in here with the correct capitalization for CloudFormation. If you pass CDK classes or structs, they will be rendered with lowercased key names, and CloudFormation will reject the template.
Parameters
pathpathpathpathPath— - The path of the property, you can use dot notation to override values in complex types.valuevaluevaluevalueValue— - The value.
addPropertyDeletionOverride(propertyPath: string): voiddef add_property_deletion_override(self, property_path: str) -> Nonepublic void addPropertyDeletionOverride(String propertyPath)public void AddPropertyDeletionOverride(string propertyPath)func AddPropertyDeletionOverride(PropertyPath *string)#1 parameter
Parameters
propertyPathproperty_pathpropertyPathpropertyPathPropertyPath— The path to the property.
addPropertyOverride(propertyPath: string, value: any): voiddef add_property_override(self, property_path: str, value: Any) -> Nonepublic void addPropertyOverride(String propertyPath, Object value)public void AddPropertyOverride(string propertyPath, object value)func AddPropertyOverride(PropertyPath *string, Value interface{})#Syntactic sugar for addOverride("Properties.<...>", value).
2 parameters
Parameters
propertyPathproperty_pathpropertyPathpropertyPathPropertyPath— The path of the property.valuevaluevaluevalueValue— The value.
addResourceDependency(target: CfnResource, reason?: string): voiddef add_resource_dependency(self, target: CfnResource, reason: typing.Optional[str] = None) -> Nonepublic void addResourceDependency(CfnResource target, String reason)public void AddResourceDependency(CfnResource target, string? reason = null)func AddResourceDependency(Target CfnResource, Reason *string)#notes
This can be used for resources across stacks (or nested stack) boundaries and the dependency will automatically be transferred to the relevant scope.
This method only adds dependencies between L1 resources. If you are looking for a generic construct-to-construct dependency mechanism that works for all constructs including L2s, use construct.node.addDependency instead.
applyCrossStackReferenceStrength(strength: ReferenceStrength): voiddef apply_cross_stack_reference_strength(self, strength: ReferenceStrength) -> Nonepublic void applyCrossStackReferenceStrength(ReferenceStrength strength)public void ApplyCrossStackReferenceStrength(ReferenceStrength strength)func ApplyCrossStackReferenceStrength(Strength ReferenceStrength)#When set, any cross-stack reference to this resource will use the specified strength instead of the global default from the consuming stack's context.
1 parameter
Parameters
strengthstrengthstrengthstrengthStrength— - The reference strength to use for this resource.
applyRemovalPolicy(policy?: RemovalPolicy, options?: RemovalPolicyOptions): voiddef apply_removal_policy(self, policy: typing.Optional[RemovalPolicy] = None, options: typing.Optional[RemovalPolicyOptions] = None) -> Nonepublic void applyRemovalPolicy(RemovalPolicy policy, RemovalPolicyOptions options)public void ApplyRemovalPolicy(RemovalPolicy? policy = null, RemovalPolicyOptions? options = null)func ApplyRemovalPolicy(Policy RemovalPolicy, Options RemovalPolicyOptions)#notes
The Removal Policy controls what happens to this resource when it stops being managed by CloudFormation, either because you've removed it from the CDK application or because you've made a change that requires the resource to be replaced.
The resource can be deleted (RemovalPolicy.DESTROY), or left in your AWS account for data recovery and cleanup later (RemovalPolicy.RETAIN). In some cases, a snapshot can be taken of the resource prior to deletion (RemovalPolicy.SNAPSHOT). A list of resources that support this policy can be found in the following link:
cfnPropertyName(cdkPropertyName: string): stringdef cfn_property_name(self, cdk_property_name: str) -> strpublic String cfnPropertyName(String cdkPropertyName)public string CfnPropertyName(string cdkPropertyName)func CfnPropertyName(CdkPropertyName *string) *string#getAtt(attributeName: string, typeHint?: ResolutionTypeHint): Referencedef get_att(self, attribute_name: str, type_hint: typing.Optional[ResolutionTypeHint] = None) -> Referencepublic Reference getAtt(String attributeName, ResolutionTypeHint typeHint)public Reference GetAtt(string attributeName, ResolutionTypeHint? typeHint = null)func GetAtt(AttributeName *string, TypeHint ResolutionTypeHint) Reference#Ideally, use generated attribute accessors (e.g. resource.arn), but this can be used for future compatibility in case there is no generated attribute.
1 parameter
Parameters
attributeNameattribute_nameattributeNameattributeNameAttributeName— The name of the attribute.
getMetadata(key: string): anydef get_metadata(self, key: str) -> Anypublic Object getMetadata(String key)public object GetMetadata(string key)func GetMetadata(Key *string) interface{}#inspect(inspector: TreeInspector): voiddef inspect(self, inspector: TreeInspector) -> Nonepublic void inspect(TreeInspector inspector)public void Inspect(TreeInspector inspector)func Inspect(Inspector TreeInspector)#1 parameter
Parameters
inspectorinspectorinspectorinspectorInspector— tree inspector to collect and process attributes.
isCfnElement(x: any): boolean@staticmethod def is_cfn_element(x: Any) -> boolpublic static Boolean isCfnElement(Object x)public static bool IsCfnElement(object x)func IsCfnElement(X interface{}) *boolstatic#Uses duck-typing instead of instanceof to allow stack elements from different versions of this library to be included in the same stack.
returns
Returns: The construct as a stack element or undefined if it is not a stack element.
isCfnResource(x: any): boolean@staticmethod def is_cfn_resource(x: Any) -> boolpublic static Boolean isCfnResource(Object x)public static bool IsCfnResource(object x)func IsCfnResource(X interface{}) *boolstatic#isCfnRotationSchedule(x: any): boolean@staticmethod def is_cfn_rotation_schedule(x: Any) -> boolpublic static Boolean isCfnRotationSchedule(Object x)public static bool IsCfnRotationSchedule(object x)func IsCfnRotationSchedule(X interface{}) *boolstatic#isConstruct(x: any): boolean@staticmethod def is_construct(x: Any) -> boolpublic static Boolean isConstruct(Object x)public static bool IsConstruct(object x)func IsConstruct(X interface{}) *boolstatic#notes · 1 parameter · returns
Use this method instead of instanceof to properly detect Construct instances, even when the construct library is symlinked.
Explanation: in JavaScript, multiple copies of the constructs library on disk are seen as independent, completely different libraries. As a consequence, the class Construct in each copy of the constructs library is seen as a different class, and an instance of one class will not test as instanceof the other class. npm install will not create installations like this, but users may manually symlink construct libraries together or use a monorepo tool: in those cases, multiple copies of the constructs library can be accidentally installed, and instanceof will behave unpredictably. It is safest to avoid using instanceof, and using this type-testing method instead.
Parameters
xxxxX— Any object.
Returns: true if x is an object created from a class which extends Construct.
obtainDependencies(): Stack | CfnResource[]def obtain_dependencies(self, ) -> typing.List[typing.Union[Stack, CfnResource]]public List<Stack> obtainDependencies()public Stack[] ObtainDependencies()func ObtainDependencies() *[]interface{}#For resources depended on directly, returns the CfnResource object. For dependencies on other stacks, returns the Stack object. The order of the array is not guaranteed.
overrideLogicalId(newLogicalId: string): voiddef override_logical_id(self, new_logical_id: str) -> Nonepublic void overrideLogicalId(String newLogicalId)public void OverrideLogicalId(string newLogicalId)func OverrideLogicalId(NewLogicalId *string)#1 parameter
Parameters
newLogicalIdnew_logical_idnewLogicalIdnewLogicalIdNewLogicalId— The new logical ID to use for this stack element.
removeDependency(target: CfnResource): voiddef remove_dependency(self, target: CfnResource) -> Nonepublic void removeDependency(CfnResource target)public void RemoveDependency(CfnResource target)func RemoveDependency(Target CfnResource)deprecated#This can be used for resources across stacks (including nested stacks) and the dependency will automatically be removed from the relevant scope.
removeResourceDependency(target: CfnResource): voiddef remove_resource_dependency(self, target: CfnResource) -> Nonepublic void removeResourceDependency(CfnResource target)public void RemoveResourceDependency(CfnResource target)func RemoveResourceDependency(Target CfnResource)#This can be used for resources across stacks (including nested stacks) and the dependency will automatically be removed from the relevant scope.
replaceDependency(target: CfnResource, newTarget: CfnResource): voiddef replace_dependency(self, target: CfnResource, new_target: CfnResource) -> Nonepublic void replaceDependency(CfnResource target, CfnResource newTarget)public void ReplaceDependency(CfnResource target, CfnResource newTarget)func ReplaceDependency(Target CfnResource, NewTarget CfnResource)#2 parameters
Parameters
targettargettargettargetTarget— The dependency to replace.newTargetnew_targetnewTargetnewTargetNewTarget— The new dependency to add.
toString(): stringdef to_string(self, ) -> strpublic String toString()public string ToString()func ToString() *string#returns
Returns: a string representation of this resource
with(...mixins: IMixin[]): IConstructdef with(self, mixins: IMixin) -> IConstructpublic IConstruct with(IMixin mixins)public IConstruct With(IMixin mixins)func With(Mixins IMixin) IConstruct#Mixins are applied in order. The list of constructs is captured at the start of the call, so constructs added by a mixin will not be visited. Use multiple with() calls if subsequent mixins should apply to added constructs.